function [dx,cv,u,x2d,mu_e,mu_de] = nivel_fuzzy(t,x,r,dt)
    
persistent i x2_ant;

if (isempty(i))
    i = 1;
    x2_ant = 0;
end

    ti = 50;
    tf = 100;
    cv = 5;
    if ((t > ti) && (t < tf))
        cv = (5*tf - 4*t - ti)/(tf - ti);
    elseif (t >= tf)
        cv = 1;
    end
   

    x2d = (x(2) - x2_ant)/dt;
    x2_ant = x(2);

    [u,mu_e,mu_de] = fuzzycontroller(x(2)-r, x2d);
    u = u - 10*x(1);
    
    if (u > 20)
        u = 20;
    elseif (u < 0)
        u = 0;
    end
    
    w = 0.1*randn(1,1);
    
    dx(1,1) = x(2) - r;
    dx(2,1) = 0.2*(u + w - cv*sqrt(x(2)));
return




function [u,mu_e,mu_de] = fuzzycontroller(e,de)

% lim_e = [-15 -10; -15 -2; -3 3; 2 15; 10 15];
% mu_e = pertinencia(e,lim_e);
% 
% lim_de = [-4 -3; -4 0; -2 2; 0 4; 3 4];
% mu_de = pertinencia(de,lim_de);

%uf = [0 0; 0 0; -5 5; 0 20; 10 30];

% tabela = [2 2 2 2 2;
%     2 1 1 1 1;
%     1 1 0 0 0;
%     0 0 0 0 0;
%     0 0 0 0 0];



lim_e = [-15 -10; -15 0; -5 5; 0 15; 10 15];
mu_e = pertinencia(e,lim_e);

lim_de = [-4 -3; -4 0; -1 1; 0 4; 3 4];
mu_de = pertinencia(de,lim_de);

%uf = [-5 5; -2 8; 0 10; 5 15; 10 20; 15 30];
uf = [-5 5; 0 10; 5 15; 10 20; 15 25];

tabela = [5 5 4 4 3; 
    4 3 3 2 2; 
    2 2 1 1 1; 
    1 1 1 1 1; 
    1 1 1 1 1];

%1 Z
%2 P 
%3 M
%4 A 
%5 T

cont = 1;
for ei=1:size(tabela,1)
    for dei=1:size(tabela,2)
        mu_u = min([mu_e(ei) mu_de(dei)]);
        if (mu_u > 0)
            tab = tabela(ei,dei); %Evitar indice 0
            centro(cont) = (uf(tab,2) + uf(tab,1))/2;
            %x = -(mu_u*(uf(tab,1) - uf(tab,2)) - uf(tab,1));
            x = -(mu_u*(uf(tab,1) - centro(cont)) - uf(tab,1));
            area(cont) = ((uf(tab,2)-uf(tab,1)) + 2*(centro(cont)-x))*mu_u/2;
            cont = cont + 1;
        end
    end
end

u = sum(centro.*area)/sum(area);

return



function mu = pertinencia(e,lim)
%Programar para retornar a area tambem

mu = zeros(1,5);

if (e <= lim(1,2)) %NA
    if (e <= lim(1,1))
        mu(1) = 1;
    else
        mu(1) = (-e + lim(1,2))/(lim(1,2) - lim(1,1));
    end
end

for p = 2:4
    if ((e >= lim(p,1)) && (e <= lim(p,2)))
        centro = (lim(p,1)+lim(p,2))/2;
        if (e <= centro)
            mu(p) = (e - lim(p,1))/(centro - lim(p,1));
        else
            mu(p) = (-e + lim(p,2))/(lim(p,2) - centro);
        end
    end
end

if (e >= lim(5,1)) %PA
    if (e >= lim(5,2))
        mu(5) = 1;
    else
        mu(p) = (e - lim(5,1))/(lim(5,2) - lim(5,1));
    end
end

return
