function [dx,cv,u] = nivel_robusto(t,x,r,K)
    
    ti = 50;
    tf = 100;
    cv = 5;
    if ((t > ti) && (t < tf))
        cv = (5*tf - 4*t - ti)/(tf - ti);
    elseif (t >= tf)
        cv = 1;
    end
    
    theta = 1/sqrt(x(2));
    alf1 = (theta-1)/(1/sqrt(20) - 1);
    u = (alf1*K{1} + (1-alf1)*K{2})*x;
    
    if (u > 20)
        u = 20;
    elseif (u < 0)
        u = 0;
    end
    
    w = 0.1*randn(1,1);
    
    dx(1,1) = r - x(2);
    dx(2,1) = 0.2*(u + w - cv*sqrt(x(2)));
return