clear;
dt = 0.01;
t = 0:dt:200;
r = 10;
[tout,x] = ode45(@(t,x) nivel_adaptativo(t,x,r),t,[0;1;0;0;0;0;0;1]);
x = real(x);

for cont=1:size(x,1)
    [dx,cv(cont),u(cont)] = nivel_adaptativo(tout(cont),x(cont,:)',r);
end

figure('units','normalized','outerposition',[0 0 1 1])
passo = 20;
for cont=1:passo:size(x,1)
    subplot(1,3,1);
    plot(tout(1:cont),x(1:cont,2),[50 50],[0 25],'r--',[100 100],[0 25],'r--');
    axis([tout(1) tout(end) 0 25]);
    title('Nível');
    subplot(1,3,2);
    plot([0 0 5],[20 0 0], 'k-',[4.5 4.5 5],[20 0.5 0.5],'k-',[0 4.5],[x(cont,2) x(cont,2)],'b-',[0 4.5],[r r],'r--');
    axis([-5 10 -1 25]);
    title('Animação');
    subplot(1,3,3);
    %%%% Plota Cv
    plot(tout(1:cont),cv(1:cont),tout(1:cont),x(1:cont,8));
    axis([tout(1) tout(end) -1 7]);
    title('Estimativa de Cv(t)');
    
    hold off
    pause(dt);
end