dt = 0.01;
t = 0:dt:200;
r = 10;
[tout,x] = ode45(@(t,x) nivel_fuzzy(t,x,r,dt),t,[0;0]);
x = real(x);

for cont=1:size(x,1)
    [dx,cv(cont),u(cont),x2d,mu_e(cont,:),mu_de(cont,:)] = nivel_fuzzy(tout(cont),x(cont,:)',r,dt);
end

figure('units','normalized','outerposition',[0 0 1 1])
passo = 10;
for cont=1:passo:size(x,1)
    if (cont == 1401)
        pause;
    end
    subplot(1,3,1);
    plot(tout(1:cont),x(1:cont,2),[50 50],[0 25],'r--',[100 100],[0 25],'r--');
    axis([tout(1) tout(end) 0 25]);
    title('Nível');
    subplot(1,3,2);
    plot([0 0 5],[20 0 0], 'k-',[4.5 4.5 5],[20 0.5 0.5],'k-',[0 4.5],[x(cont,2) x(cont,2)],'b-',[0 4.5],[r r],'r--');
    axis([-5 10 -1 25]);
    title('Animação');
%     %%%% Plota u
%     subplot(1,3,3);
%     plot(tout(1:cont),u(1:cont));
%     axis([tout(1) tout(end) -1 22]);

    %%%%% Plota pertinencia
    subplot(1,3,3);
    plot([-3 3],[2 2],'k-',[-3 3],[1 1],'k-',[-3 3],[0 0],'k-',[-3 3],[-1 -1],'k-',[-3 3],[-2 -2],'k-');
    hold on
    plot([-2 -2],[-3 3],'k-',[-1 -1],[-3 3],'k-',[0 0],[-3 3],'k-',[1 1],[-3 3],'k-',[2 2],[-3 3],'k-');
    text(-1.7, 2.3, 'NA');
    text(-0.7, 2.3, 'NB');
    text( 0.3, 2.3, 'Z');
    text( 1.3, 2.3, 'PB');
    text( 2.3, 2.3, 'PA');
    text(-2.7,1.5,'NA');
    text(-2.7,0.5,'NB');
    text(-2.7,-0.5,'Z');
    text(-2.7,-1.5,'PB');
    text(-2.7,-2.5,'PA');
    text(-4,0,'Erro');
    text(-1,4,'Variação');
    inde = find(real(mu_e(cont,:)) > 0.001);
    indde = find(real(mu_de(cont,:)) > 0.001);
    for ide=1:length(inde)
        for idde=1:length(indde)
            fill([indde(idde)-3 indde(idde)-2 indde(idde)-2 indde(idde)-3],[-inde(ide)+2 -inde(ide)+2 -inde(ide)+3 -inde(ide)+3],(1-min([mu_e(cont,inde(ide)) mu_de(cont,indde(idde))]))*[1 1 1]);
            %plot(indde(idde)+0.5,inde(ide)+0.5,'r*','MarkerSize',10,'MarkerEdgeColor','b','MarkerFaceColor',[1,0,0]);
            hold on;
            axis([-5 5 -5 5]);
        end
    end
    title('Pertinências');
    
    hold off
    pause(dt);
end