clear;
Ai{1} = {[1 0],[1 0],[0 -1; 0 -0.2/sqrt(20)]};
Ai{2} = {[1 0],[0 1],[0 -1; 0 -5*0.2/sqrt(20)]};
Ai{3} = {[0 1],[1 0],[0 -1; 0 -0.2]};
Ai{4} = {[0 1],[0 1],[0 -1; 0 -5*0.2]};

dotbounds{1} = [-5 5; -5 5];
dotbounds{2} = [-5 5; -5 5];

A = rolmipvar(Ai,'A',[2 2],[1 1]);
Bu = rolmipvar([0;0.2],'Bu',0,0);
Bw = rolmipvar([0;0.2],'Bw',0,0);
Cz = rolmipvar([0 0],'Cz',0,0);
Dzu = rolmipvar([1],'Dzu',0,0);
Dzw = rolmipvar([0],'Dzw',0,0);

P = rolmipvar(2,2,'P','sym',[2 2],[1 1]);
Z = rolmipvar(1,2,'Z','full',0,0);
%G = rolmipvar(2,2,'G','full',0,0);
G = rolmipvar(2,2,'G','full',[2 2],[1 0]);
xi = rolmipvar(1,'xi','scalar');
V = rolmipvar(1,1,'V','full',[2 2],[1 1]);
gamaquad = 2;%sdpvar(1,1); 
gamar = rolmipvar(gamaquad,'gama','scalar');
dotP = diff(P,dotbounds);

T11 = A*G + G'*A' + Bu*Z + Z'*Bu' - dotP;
T21 = P - G + xi*(A*G+Bu*Z)';
T31 = Cz*G + Dzu*Z;
T41 = -V'*Bw';
T22 = -xi*(G+G');
T32 = xi*(Cz*G + Dzu*Z);
T42 = zeros(1,2);
T33 = -gamar*eye(1);
T43 = -V'*Dzw';
T44 = eye(1) + V + V';

T = [T11 T21' T31' T41'; 
    T21 T22 T32' T42';
    T31 T32 T33 T43';
    T41 T42 T43 T44];

LMIs = [P > 0, T < 0];

%%%H2
Cz2 = rolmipvar([1 1],'Cz2',0,0);
Dzu2 = rolmipvar([0.1],'Dzu2',0,0);
Xi = sdpvar(1,1,'sym'); X = rolmipvar(Xi,'X',0,0);
P2 = rolmipvar(2,2,'P2','sym',[2 2],[1 1]);
dotP2 = diff(P2,dotbounds);
V2 = rolmipvar(1,1,'V','full',[2 2],[1 1]);
T11 = A*G+Bu*Z+G'*A'+Z'*Bu' - dotP;
T12 = P2-G'+xi*(A*G+Bu*Z);
T13 = Bw*V2;
T22 = xi*(-G-G');
T23 = zeros(2,1);
T33 = eye(1)-V2-V2';
T = [T11 T12 T13; T12' T22 T23; T13' T23' T33];
LMIs = [LMIs, P2 > 0, T < 0, [-X Cz2*G+Dzu2*Z; (Cz2*G+Dzu2*Z)' P2-G-G'] < 0];


solvesdp(LMIs,trace(Xi));
[p,d] = checkset(LMIs);
if (min(p) > -1e-7)
    aux = coeffs(G);
    K{1} = double(Z)*inv(double(aux{1}));
    K{2} = double(Z)*inv(double(aux{2}));
end
